//
//  CalculatorBrain.h
//  Stanford_Cal_Assignment_1
//
//  Created by LauRi3A on 1/07/12.
//  Copyright (c) 2012 Beginning. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface CalculatorBrain : NSObject

//Public API
-(void)pushOperand:(double)operand;
-(void)pushVariable:(NSString *)variable;
-(void)pushOperation:(NSString *)operation;
-(double)performOperation:(NSString *)operation;

@property (nonatomic, readonly) id program;

+(double)runProgram:(id)program;
+(double)runProgram:(id)program usingVariableValues:(NSDictionary *)variableValues;
+(NSSet *)variablesUsedInProgram:(id)program;
+(NSString *)descriptionOfProgram:(id)program;

@end
